#include <stdio.h>


void print_names_ages(int count, char *names[], int ages[], const char *fmt)
{
    int i;
    for(i = 0; i < count; i++) {
        printf(fmt, names[i], ages[i]);
    }
    printf("---\n");
}


int main(int argc, char *argv[])
{
    // create two arrays we care about
    int ages[] = {23, 43, 12, 89, 2};
    char *names[] = {
        "Alan", "Frank",
        "Mary", "John", "Lisa"
    };
    // safely get the size of ages
    int count = sizeof(ages) / sizeof(int);

    print_names_ages(count, names, ages, "%s has %d years alive.\n");
    print_names_ages(count, names, ages, "%s is %d years old.\n");
    print_names_ages(count, names, ages, "%s is %d years old again.\n");
    print_names_ages(count, names, ages, "%s lived %d years so far.\n");

    int i;
    char **arg = argv;
    for(i = 0; i < argc; i++) {
        printf("argument %d is '%s' (address = %p)\n", i, *arg, arg);
        arg++;
    }

    return 0;
}
